typedef union
{
  int number;
  FLOAT_TYPE fnum;
  unsigned int address;		/* Address of an instruction */
  struct pike_string *string;
  char *str;
  unsigned short type;
  struct node_s *n;
  struct efun *efun;
} YYSTYPE;
#define	F_PREFIX_256	258
#define	F_PREFIX_512	259
#define	F_PREFIX_768	260
#define	F_PREFIX_1024	261
#define	F_PREFIX_CHARX256	262
#define	F_PREFIX_WORDX256	263
#define	F_PREFIX_24BITX256	264
#define	F_POP_VALUE	265
#define	F_POP_N_ELEMS	266
#define	F_MARK	267
#define	F_MARK2	268
#define	F_CALL_LFUN	269
#define	F_CALL_LFUN_AND_POP	270
#define	F_APPLY	271
#define	F_APPLY_AND_POP	272
#define	F_MARK_APPLY	273
#define	F_MARK_APPLY_POP	274
#define	F_BRANCH	275
#define	F_BRANCH_WHEN_ZERO	276
#define	F_BRANCH_WHEN_NON_ZERO	277
#define	F_BRANCH_WHEN_LT	278
#define	F_BRANCH_WHEN_GT	279
#define	F_BRANCH_WHEN_LE	280
#define	F_BRANCH_WHEN_GE	281
#define	F_BRANCH_WHEN_EQ	282
#define	F_BRANCH_WHEN_NE	283
#define	F_INC_LOOP	284
#define	F_DEC_LOOP	285
#define	F_INC_NEQ_LOOP	286
#define	F_DEC_NEQ_LOOP	287
#define	F_INDEX	288
#define	F_ARROW	289
#define	F_INDIRECT	290
#define	F_STRING_INDEX	291
#define	F_LOCAL_INDEX	292
#define	F_POS_INT_INDEX	293
#define	F_NEG_INT_INDEX	294
#define	F_LTOSVAL	295
#define	F_LTOSVAL2	296
#define	F_PUSH_ARRAY	297
#define	F_RANGE	298
#define	F_COPY_VALUE	299
#define	F_LFUN	300
#define	F_GLOBAL	301
#define	F_LOCAL	302
#define	F_2_LOCALS	303
#define	F_MARK_AND_LOCAL	304
#define	F_GLOBAL_LVALUE	305
#define	F_LOCAL_LVALUE	306
#define	F_CLEAR_LOCAL	307
#define	F_CLEAR_2_LOCAL	308
#define	F_CLEAR_STRING_SUBTYPE	309
#define	F_CONSTANT	310
#define	F_FLOAT	311
#define	F_STRING	312
#define	F_ARROW_STRING	313
#define	F_NUMBER	314
#define	F_NEG_NUMBER	315
#define	F_CONST_1	316
#define	F_CONST0	317
#define	F_CONST1	318
#define	F_BIGNUM	319
#define	F_INC	320
#define	F_DEC	321
#define	F_POST_INC	322
#define	F_POST_DEC	323
#define	F_INC_AND_POP	324
#define	F_DEC_AND_POP	325
#define	F_INC_LOCAL	326
#define	F_INC_LOCAL_AND_POP	327
#define	F_POST_INC_LOCAL	328
#define	F_DEC_LOCAL	329
#define	F_DEC_LOCAL_AND_POP	330
#define	F_POST_DEC_LOCAL	331
#define	F_RETURN	332
#define	F_DUMB_RETURN	333
#define	F_RETURN_0	334
#define	F_RETURN_1	335
#define	F_THROW_ZERO	336
#define	F_ASSIGN	337
#define	F_ASSIGN_AND_POP	338
#define	F_ASSIGN_LOCAL	339
#define	F_ASSIGN_LOCAL_AND_POP	340
#define	F_ASSIGN_GLOBAL	341
#define	F_ASSIGN_GLOBAL_AND_POP	342
#define	F_ADD	343
#define	F_SUBTRACT	344
#define	F_ADD_INT	345
#define	F_ADD_NEG_INT	346
#define	F_MULTIPLY	347
#define	F_DIVIDE	348
#define	F_MOD	349
#define	F_LT	350
#define	F_GT	351
#define	F_EQ	352
#define	F_GE	353
#define	F_LE	354
#define	F_NE	355
#define	F_NEGATE	356
#define	F_NOT	357
#define	F_COMPL	358
#define	F_AND	359
#define	F_OR	360
#define	F_XOR	361
#define	F_LSH	362
#define	F_RSH	363
#define	F_LAND	364
#define	F_LOR	365
#define	F_EQ_OR	366
#define	F_EQ_AND	367
#define	F_SWITCH	368
#define	F_SSCANF	369
#define	F_CATCH	370
#define	F_CAST	371
#define	F_FOREACH	372
#define	F_SIZEOF	373
#define	F_SIZEOF_LOCAL	374
#define	F_ADD_TO_AND_POP	375
#define	F_MAX_OPCODE	376
#define	F_ADD_EQ	377
#define	F_AND_EQ	378
#define	F_ARG_LIST	379
#define	F_ARRAY_ID	380
#define	F_BREAK	381
#define	F_CASE	382
#define	F_CLASS	383
#define	F_COLON_COLON	384
#define	F_COMMA	385
#define	F_CONTINUE	386
#define	F_DEFAULT	387
#define	F_DIV_EQ	388
#define	F_DO	389
#define	F_DOT_DOT	390
#define	F_DOT_DOT_DOT	391
#define	F_PREDEF	392
#define	F_EFUN_CALL	393
#define	F_ELSE	394
#define	F_FLOAT_ID	395
#define	F_FOR	396
#define	F_FUNCTION_ID	397
#define	F_GAUGE	398
#define	F_IDENTIFIER	399
#define	F_IF	400
#define	F_IMPORT	401
#define	F_INHERIT	402
#define	F_INLINE	403
#define	F_INT_ID	404
#define	F_LAMBDA	405
#define	F_MULTISET_ID	406
#define	F_MULTISET_END	407
#define	F_MULTISET_START	408
#define	F_LSH_EQ	409
#define	F_LVALUE_LIST	410
#define	F_MAPPING_ID	411
#define	F_MIXED_ID	412
#define	F_MOD_EQ	413
#define	F_MULT_EQ	414
#define	F_NO_MASK	415
#define	F_OBJECT_ID	416
#define	F_OR_EQ	417
#define	F_PRIVATE	418
#define	F_PROGRAM_ID	419
#define	F_PROTECTED	420
#define	F_PUBLIC	421
#define	F_RSH_EQ	422
#define	F_STATIC	423
#define	F_STATUS	424
#define	F_STRING_ID	425
#define	F_SUBSCRIPT	426
#define	F_SUB_EQ	427
#define	F_TYPEOF	428
#define	F_VAL_LVAL	429
#define	F_VARARGS	430
#define	F_VOID_ID	431
#define	F_WHILE	432
#define	F_XOR_EQ	433
#define	F_NOP	434
#define	F_ALIGN	435
#define	F_POINTER	436
#define	F_LABEL	437
#define	F_BYTE	438
#define	F_MAX_INSTR	439

